<?php

if(!class_exists('MDHQCRelayRedbox')) {
    class MDHQCRelayRedbox
    {
        const NUTRIMENT_IP_ADDRESS = '66.103.159.94';

        public function __construct()
        {
            if (!is_admin()) {
                add_action('init', array($this, 'handle_request'));
            }
        }

        public function handle_request()
        {
            if (empty($_GET['redbox_redirect'])) {
                return;
            }

            if (empty($_GET['email']) || empty($_GET['user_id'])) {
                echo "empty request";
                die;
            }

			$patientId = $_GET['user_id'];
            $currentCartItems = $this->get_current_cart($_GET['email']);
            $purchasedItems = $this->get_ordered_items($_GET['email']);
            $userId = 0;
            $user = get_user_by_email($_GET['email']);
            $nrlink = '';
            if ($user instanceof WP_User) {
                $userId = $user->ID;
                $link = get_user_meta($userId, 'nr_link', true);
                if (!empty($link)) {
                    $nrlink = get_site_url() . "/my-account/?nrlogin=" . $link;
                }
            }
			
			wp_set_current_user($userId);
            wp_set_auth_cookie($userId);
			global $current_user;
			wp_get_current_user();

			$session_handler = new WC_Session_Handler();
			$session = $session_handler->get_session($userId);
			if(isset($session['cart']) && $session['cart']!=""){
				$currentCartItems = maybe_unserialize($session['cart']);
			}
			
            $url = rtrim(get_site_url(), '/') . "/?user_id=" . $userId . '&mdhqd_send_now=1';
            $data = ['currentCartItems' => $currentCartItems, 'purchasedItems' => $purchasedItems, 'userId' => $userId, 'url' => $url, 'nrLink' => $nrlink, 'patientId' => $patientId];
            echo $this->render($data, __DIR__ . "/views/redbox-view.php");
            die;
        }

        public function render($data, $template)
        {
            ob_start();
            if(!empty($data))
                extract($data);
            include($template);
            return ob_get_clean();
        }

        // Function to get the client IP address
        private function get_client_ip() {
            $ipaddress = '';
            if (isset($_SERVER['HTTP_CLIENT_IP']))
                $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
            else if(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
                $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
            else if(isset($_SERVER['HTTP_X_FORWARDED']))
                $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
            else if(isset($_SERVER['HTTP_FORWARDED_FOR']))
                $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
            else if(isset($_SERVER['HTTP_FORWARDED']))
                $ipaddress = $_SERVER['HTTP_FORWARDED'];
            else if(isset($_SERVER['REMOTE_ADDR']))
                $ipaddress = $_SERVER['REMOTE_ADDR'];
            else
                $ipaddress = 'UNKNOWN';
            return $ipaddress;
        }

        private function get_ordered_items($email)
        {
            $query = new WC_Order_Query();
            $query->set('customer', $email);
            $orders = $query->get_orders();
            $items = array();
			// $order_date = "";
			// $order_ids = "";
            foreach ($orders as $order) {
				// echo "<pre>";
					// print_r($order->get_id());
					// echo "</pre>";
					
					// echo "<pre>";
					// print_r($order->order_date);
					// echo "</pre>";
					
					
                $products = $order->get_items();
				
                foreach ($products as $product) {
					// echo "<pre>";
					// print_r($product);
					// echo "</pre>";
					
					
                    $product_id = $product->get_product_id();
					// $order_date[$order->get_id()]= $order->order_date;
					// $order_ids[$order->get_id()]= $order->get_id();
                    if (!in_array($product_id, array_keys($items))) {
                        $items[$product_id] = array(
                            'name' => $product->get_name(),
                            'quantity' => $product->get_quantity(),
							// 'order_id' => $order_ids,
							// 'order_date' => $order_date
                        );
                    } else {
                        $items[$product_id]['quantity'] = $items[$product_id]['quantity'] + $product->get_quantity();
                    }
                }
            }
            return $items;
        }

        private function get_current_cart($email)
        {
            $users = get_users(array('search' => $email));
            $user = array();
            if ($users)
                $user = array_shift($users);
            if (!$user)
                return false;
            return get_user_meta($user->data->ID, '_woocommerce_persistent_cart_1', true);
        }
    }
}